#include "usgard.h"

.org    0
ProgAddr:
.db	0

WIN_CALLER:
	ld	(&Save_A), A
	ld	(&Save_HL), HL
	pop	HL
	ld	A, (HL)
	inc	HL
	push	HL
	push	DE
	add	A, A
	ld	E, A
	ld	D, 0
	ld	HL, &Procs
	add	HL, DE
	call	LD_HL_MHL
	ld	DE, &ProgAddr
	add	HL, DE
	pop	DE
	push	HL
	ld	HL, (&Save_HL)
	ld	A, (&Save_A)
	ret

Save_A: .db 0
Save_HL: .dw 0

Procs:
.dw     fWIN_PREPARE
.dw     fWIN_SHOW
.dw     fWIN_CLEAR
.dw     fWIN_ERROR
.dw     fWIN_CHOICE
.dw     fWIN_PSHOW
.dw     Invert
.dw     fWIN_CHC_EX

;WIN_PREPARE:
;Input: B,C upper left corner of window(X/8)
;       H,L size(X/8)
;       DE  pointer to title
;       IX  pointer to contents
;       A   status byte
;Output:HL  pointer to windows area
fWIN_PREPARE:
	bit     2, A
	jr      z, StartPrepare
	push    AF
	ld	A, (WIN_STAT)
	bit	0, A
	jr	z, DoneHide
	push	hl
	push	de
	push	bc
	ld	hl, (WIN_REGION)
	ld	de, -96
	add	hl, de
	ld	(WIN_REGION), hl
	ld	c, 0
	call	&Invert
	pop	bc
	pop	de
	pop	hl
DoneHide:
	pop     af
	res     2, A
StartPrepare:
	ld      (WIN_POSY),   BC
	ld      (WIN_HGT),  HL
	ld      (WIN_TITLE), DE
	ld      (WIN_CONT),  IX
	ld      E, H
	or      11000000b
	ld      D, A
	bit     0, D
	ld      A, L
	jr      z, SetRSize
	sub     6
SetRSize:
	sub     2
	ld      L, A
	ld      (WIN_RSIZE), hl
	ld      a, c
	bit     0, d
	jr      z, NoTitle_Y
	add     a, 6
NoTitle_Y:
	inc     a
	ld      h, a
	ld      a, b
	add     a, a
	add     a, a
	add     a, a
	inc     a
	ld      l, a
	ld      (WIN_TEXTX), hl
	dec     a
	jr      nz, DrawLeftBorder
	res     6, d
DrawLeftBorder:
	ld      a, b
	add     a, e
	cp      16
	jr      c, DrawRightBorder
	res     7, d
DrawRightBorder:
	ld      A, D
	ld      (WIN_STAT), A
	ld      HL, 0
	ld      (WIN_SCRLY), HL
	ld      l, c
	ld      d, h
	ld      e, b
	add     hl, hl
	add     hl, hl
	add     hl, hl
	add     hl, hl
	add     hl, de
	ld      bc, (WIN_DEST_ADDR)
	add     hl, bc
	ld      (WIN_ADDR), hl
	ld      e, 16
	rra                    ;A retained from above
	jr     nc, NoTitle
	ld     e, 112
NoTitle:
	add    hl, de
	ld     (WIN_REGION), hl
	ret    ;= 80 bytes

;WIN_SHOW.
;Input: none
;Output: draws the window
fWIN_SHOW:
	ld      hl, (WIN_ADDR)
	ld      bc, (WIN_HGT)
	ld      a,  (WIN_STAT)
	ld      de, 16
	push    hl
	push    bc
	bit     6, a
	jr      z, WIN_RIGHTB   ;Don't draw left border
	dec     hl
WIN_LeftBorder:
	set     0, (hl)
	add     hl, de
	dec     c
	jr      nz, WIN_LeftBorder
WIN_RIGHTB:
	pop     bc
	pop     hl
	push    hl
	rlca
	jr      nc, WIN_TITLEx
	push    bc
	ld      c, b
	ld      b, 0
	add     hl, bc
	pop     bc
WIN_RightBorder:
	set     7, (hl)
	add     hl, de
	dec     c
	jr      nz, WIN_RightBorder
WIN_TITLEx:
	pop     hl
	push    hl
	ld      a, 16
	sub     b
	ld      e, a
	ld      d, 0
	ld      c, 7
WIN_TitleLoop:
	push    bc
	ld      a, 255
WIN_TitleXLoop:
	ld      (hl), a
	inc     hl
	djnz    WIN_TitleXLoop
	pop     bc
	ld      A, (WIN_STAT)
	rrca
	jr      nc, WIN_BOTTOM
	add     hl, de
	dec     c
	jr      nz, WIN_TitleLoop
DrawTitleText:
	set     3, (iy+05)
	ld      hl, (WIN_POSY)
	ld      h, l
	ld      a, (WIN_TEXTX)
	ld      l, a
	ld      (CURSOR_X), hl
	ld      hl, (WIN_TITLE)
	ld	d, 128
	call	&WIN_Parse
	;call    D_ZM_STR
	res     3, (iy+05)
WIN_BOTTOM:
	ld      hl, (WIN_HGT)
	ld      b, h
	ld      c, l
	ld      h, 0
	dec     l
	add     hl, hl
	add     hl, hl
	add     hl, hl
	add     hl, hl
	pop     de
	add     hl, de
WIN_BOTTOML:
	ld      (hl), 255
	inc     hl
	djnz    WIN_BOTTOML             ;Now the window drawing is finished
;* Clear the window and draw the contents:
	call    &fWIN_CLEAR
	ld      a, (WIN_STAT)
	bit     1, a
	ret     z
;Calculate length of string
	ld      hl, (WIN_CONT)
	push    hl
	ld      bc, 65535
SearchEnd:
	xor     a
	cpir
	push    hl
	pop     ix
	ld      a, NUM
	cp      (ix-2)
	jr      z, SearchEnd
	cp      (ix-3)
	jr      z, SearchEnd

	call    NEG_BC

	ld      a, 1
	ld      (WIN_LINE), a

	ld      hl, (WIN_TEXTX)
	ld      (CURSOR_X), hl
	ld      e, l
	pop     hl
;Calculate offset to start with(ScrlY)
	ld      a, (WIN_SCRLY)
	and     a
	jr      z, WIN_NoAdjust
	ld      d, a
	ld      a, LF
WIN_CalcOffsL:
	cpir
	ret     po
	dec     d
	jr      nz, WIN_CalcOffsL
WIN_NoAdjust:
	ld      d, e
	ld      a, (WIN_WDT)
	add     a, a
	add     a, a
	add     a, a
	add     a, d
	sub     5
	ld      d, a

WIN_Parse:      ;Write out the text!
	ld      a, (hl)
	inc     hl
	and     a
	ret     z
	push    AF
	push    HL
	ld      HL, CURSOR_X
	cp      245
	jp      c, &WIN_CheckNorm        ;Control characters:
	inc     a                       ; 255 - line feed
	jp      z, &WIN_LineFeed1
	inc     a                       ; 254 - tab(+16)
	jp      z, &WIN_Tab
	inc     a                       ; 253 - print out next word as number
	jr      z, WIN_Number
	inc     a
	jr      z, WIN_SetTab1          ; 252 - set first tab
	inc     a
	jr      z, WIN_SetTab2          ; 251 - set second tab
	inc     a
	jr      z, WIN_GoTab1           ; 250 - go to first tab
	inc     a
	jr      z, WIN_GoTab2           ; 249 - go to second tab
	inc	a
	jr	z, WIN_XTab		; 248 - tabulator
	inc	a
	jr	z, WIN_ByteNum		; 247 - byte number
	inc	A
	jr	z, WIN_YTab
WIN_Line:
	push	DE
	ld	A, (CURSOR_Y)
	add	A, A
	ld	L, A
	ld	H, 0
	add	HL, HL
	add	HL, HL
	add	HL, HL
	ld	A, (WIN_POSX)
	add	A, 48
	ld	E, A
	ld	D, 0
	add	HL, DE
	ld	DE, (WIN_DEST_ADDR)
	add	HL, DE
	ld	A, (WIN_WDT)
	ld	B, A
Hyphen_FillLoop:
	ld	(HL), $FF
	inc	HL
	djnz	Hyphen_FillLoop
	pop	DE
	jr	WIN_SkipChar
WIN_YTab:
	pop     hl
	ld      a, (hl)
	inc     hl
	push    hl
	ld      hl, CURSOR_Y
	add     a, (hl)
	ld      (hl), a
	jr      WIN_SkipChar
WIN_ByteNum:
	pop	HL
	ld	A, (HL)
	inc	HL
	push	HL
	ld	L, A
	ld	H, 0
	ld	A, (CURSOR_X)
	sub	8
	ld	(CURSOR_X), A
	call	&DisplayNumber
	jr	WIN_SkipChar
WIN_XTab:
	pop     hl
	ld      a, (hl)
	inc     hl
	push    hl
	ld      hl, CURSOR_X
	add     a, (hl)
	ld      (hl), a
	jr      WIN_SkipChar
WIN_GoTab2:
	ld      a, (WIN_TAB2)
	ld      (hl), a
	jr      WIN_SkipChar
WIN_GoTab1:
	ld      a, (WIN_TAB1)
	ld      (hl), a
	jr      WIN_SkipChar
WIN_SetTab1:
	ld      a, (hl)
	ld      (WIN_TAB1), a
	jr      WIN_SkipChar
WIN_SetTab2:
	ld      a, (hl)
	ld      (WIN_TAB2), a
	jr      WIN_SkipChar
WIN_Number:
	pop     hl
	push    hl
	call    LD_HL_MHL
	call	&DisplayNumber
	pop     hl
	inc     hl
	inc     hl
	jr      WIN_Skip1
WIN_Tab:
	ld      a, (hl)
	and     11110000b
	add     a, 16
	ld      (hl), a
WIN_SkipChar:
	pop     hl
WIN_Skip1:
	pop     AF
	jr      R_PRS
WIN_LineFeed1:
	call    &WIN_LineFeed
	jr      WIN_SkipChar

WIN_CheckNorm:
	ld      a, (hl)
	cp      d
	call    nc, &WIN_LineFeed
WIN_WriteChar:
	pop     HL
	pop     AF
	push    DE
	call    M_CHARPUT
	pop     DE
R_PRS:	jp      WIN_Parse
	ret

WIN_LineFeed:
	push    de
	ld      a, (WIN_POSY)
	ld      d, a
	ld      a, (WIN_HGT)
	add     a, d
	sub     6
	ld      d, a
	inc     hl
	ld      a, (hl)
	add     a, 6
	cp      d
	jr      c, WIN_NoExit
	pop     de
	pop     hl
	pop     hl
	pop     af
	ret
WIN_NoExit:
	ld      (hl), a
	dec     hl
	ld      (hl), e
	ld      hl, WIN_LINE
	inc     (hl)
	pop     de
	ret

DisplayNumber:
	push	DE
	ld	A, (WIN_OUTPUT)
	dec	A
	jr	z, HexOutput
	call	DM_HL_DECI
	pop	DE
	ret
HexOutput:
	ld	A, H
	and	A
	ld	B, 4
	jr	nz, D_A_HEX_LOOP
	ld	H, L
	ld	B, 2
	ld	A, (CURSOR_X)
	add	A, 8
	ld	(CURSOR_X), A
D_A_HEX_LOOP:
	xor     A
	add     HL, HL
	rla
	add     HL, HL
	rla
	add     HL, HL
	rla
	add     HL, HL
	rla

	cp      10
	jr      nc, AtoF
	add     A, '0'
	jr      CHAUG_DONE
AtoF:
	add     A, 'A'-10
CHAUG_DONE:
	call	M_CHARPUT
	djnz    D_A_HEX_LOOP
	pop	DE
	ret

;Error window
fWIN_ERROR:
	call    INT_CLEAN
	ld      A, $3C
	out     (5), A
	ld      BC, $0410
	ld      HL, $0820
	ld      DE, &ErrorStr
	ld      A, 255
	call    &fWIN_PREPARE
	call    &fWIN_SHOW
	call    OTH_PAUSE
	ld      A, (USG_BITS)
	bit     3, A
	ret     z
	call    OTH_EXIT

ErrorStr:
 .db "Error:",0

fWIN_CHOICE:
	ld      HL, &RetF
fWIN_CHC_EX:
CHOICE_START:
	ld      (&R_CLF+1), HL
	ld	(WIN_FUNC), HL

	ld      (iy+08), $8C


	ld      A, (WIN_LINE)
	cp      B
	jr      c, CHOICE_1
	ld      A, B
	ld      (WIN_LINE), A
CHOICE_1:
	ld      C, 0            ;C = actual choice, relative to window
	ld      D, C            ;D = absolute actual choice
CHOICE_Redraw:
	push    BC
	push    DE
	call    &fWIN_SHOW
	pop     DE
	pop     BC
CHOICE_Redraw1:
	call    &Invert
CHOICE_Loop:
	push    DE
	push    BC

	ld      HL, (WIN_FUNC)
	ld      (&R_CLF+1), hl

R_CLF:	call    RetF
	pop     BC
	pop     DE
	and     a
	jr      z, CHOICE_Loop
	call    &Invert

	call    $115

	ld      hl, WIN_SCRLY
	cp      K_UP
	jr      z, MoveUp
	cp      K_DOWN
	jr      z, MoveDown
	cp      K_ENTER
	jr      z, CHOICE_Exit
	cp      K_SECOND
	jr      z, CHOICE_Exit
	cp      K_EXIT
	jr      nz, CHOICE_Redraw
	scf
CHOICE_Exit:
	ld      a, d
	ld      (iy+08), $84
	ret

RetF:
	halt
	call    GET_KEY
	ret

MoveUp:
	ld      a, d
	and     a
	jr      z, CHOICE_Redraw1
	dec     d
	dec     c
	ld      a, c
	inc     a
	jr      nz, CHOICE_Redraw1
	dec     (hl)
	inc     c
	jr      CHOICE_Redraw
MoveDown:
	ld      a, d
	cp      b
	jr      z, CHOICE_Redraw1
	inc     d
	inc     c
	ld      a, (WIN_LINE)
	cp      c
	jr      nz, CHOICE_Redraw1
	inc     (hl)
	dec     c
	jr      CHOICE_Redraw

Invert:
	push    af
	push    de
	push    bc
	ld      de, 96
	ld      hl, (WIN_REGION)
	ld      a, c
	and     a
	jr      z, NoInv
Inv_AddLoop:
	add     hl, de
	dec     c
	jr      nz, Inv_AddLoop
NoInv:
	ld      a, 16
	ld      bc, (WIN_HGT)
	sub     b
	ld      e, a
	ld      c, 7
Inv_Loop:
	push    bc
Inv_ILoop:
	ld      a, (hl)
	cpl
	ld      (hl), a
	inc     hl
	djnz    Inv_ILoop
	pop     bc
	add     hl, de
	dec     c
	jr      nz, Inv_Loop
	pop     bc
	pop     de
	pop     af
	ret

fWIN_PSHOW:
	call    &fWIN_PREPARE
	call    &fWIN_SHOW
	ret

;WIN_CLEAR
;clears the contents of the actual window
fWIN_CLEAR:
	ld      a, 16
	ld      bc, (WIN_RSIZE)
	sub     b
	ld      e, a
	xor     a
	ld      d, a
	ld      hl, (WIN_REGION)
WIN_YCLEAR:
	push    bc
WIN_XCLEAR:
	ld      (hl), a
	inc     hl
	djnz    WIN_XCLEAR
	pop     bc
	add     hl, de
	dec     c
	jr      nz, WIN_YCLEAR
	ret    ;= 29 bytes

;WINDOW DATA:
;WIN_DATA        = 
WIN_DATA        = TEMP_STORAGE+87
WIN_POS 	= WIN_DATA	;Y position, X pos / 8
WIN_POSY	= WIN_DATA
WIN_POSX	= WIN_DATA+1
WIN_SIZE	= WIN_DATA+2	;Y size, X size / 8
WIN_HGT		= WIN_DATA+2
WIN_WDT		= WIN_DATA+3
WIN_SCRLPOS	= WIN_DATA+4	;Y scrolling position, X not supported(only graph)
WIN_SCRLY	= WIN_DATA+4
WIN_ADDR	= WIN_DATA+6	;(Y*16)+X+VIDEO_MEM
WIN_TITLE	= WIN_DATA+8	;pointer to title string
WIN_CONT	= WIN_DATA+10	;pointer to contents
WIN_STAT	= WIN_DATA+12	;Status byte:   bit 0:  draw title?
				;               bit 1:  draw contents?
				;		bit 2:  deactualize old win?
				;               bit 6:  draw left border?
				;               bit 7:  draw right border?
WIN_TEXTX	= WIN_DATA+13	;text X starting position inside window
WIN_TEXTY	= WIN_DATA+14	;text Y starting position
WIN_REGION	= WIN_DATA+15	;(Y*16)+X+VIDEO_MEM+128 (the window drawing reg.)
WIN_RSIZE	= WIN_DATA+17	;size of the drawing region
WIN_TAB1	= WIN_DATA+19	;TAB 1 position
WIN_TAB2	= WIN_DATA+20	;TAB 2 position
WIN_LINE	= WIN_DATA+21	;number of lines which fit into window
WIN_FUNC	= WIN_DATA+22	;function being called during WIN_CHOICE loop
WIN_DEST_ADDR	= WIN_DATA+24
WIN_OUTPUT	= WIN_DATA+30

;CONTROL CHARACTERS FOR CONTENTS
LF = 255	;Linefeed
TAB = 254	;Normal tabulator(X & $F0 + 16)
NUM = 253	;show next word as unsigned number
STAB1 = 252	;Set 1st tab to actual position
STAB2 = 251	;Set 2nd tab
GTAB1 = 250	;Go to 1st tab
GTAB2 = 249	;Go to 2nd tab
XTAB = 248	;go (next byte) pixels to the right
BNUM = 247	;display next byte as unsigned number
YTAB = 246	;go (next byte) pixels down
LINE = 245


.end
